function [FlowSPD_output_upsample_filename] = for_5_upsampling_v2(FlowSPD_output_filename,all_filenames)

data=[]; sample_group_assign=[];sample_group_progression_tree=[];is_marker_selected=[];

loaded_result_file = FlowSPD_output_filename;
FlowSPD_output_upsample_filename = [loaded_result_file(1:end-4),'_node_medians'];

load(loaded_result_file,'data','sample_group_assign','sample_group_progression_tree','is_marker_selected','marker_names');
downsampled_data = data;
downsampled_marker_names = marker_names;
downsampled_assign = sample_group_assign;
adj = sample_group_progression_tree;
used_marker_names = sort(marker_names(is_marker_selected==1));
[C, ind_downsampled_data, IB] = intersect(downsampled_marker_names,used_marker_names);

node_median = NaN + zeros(length(all_filenames),size(adj,1),length(downsampled_marker_names));

for file_ind = 1:length(all_filenames)
    tic
    load([all_filenames{file_ind}(1:end-4),'.mat'],'data','marker_names');
    [C, ind_original_data, IB] = intersect(marker_names,used_marker_names);
    assign = zeros(1,size(data,2));
    fprintf(['mapping/gating ',all_filenames{file_ind},' ... %d cells\n %10d'],length(assign),0);
    tmp = zeros(1,size(adj,1));
    
    
    for i=1:size(data,2)
        % data(ind_original_data,i) vs downsampled_data(ind_downsampled_data,:)
        dist = zeros(1,size(downsampled_data,2));
        for k=1:length(ind_original_data)
            dist = dist + abs(downsampled_data(ind_downsampled_data(k),:)-data(ind_original_data(k),i));
        end
        [Y,I] = sort(dist);
        if downsampled_assign(I(1))==downsampled_assign(I(2))
            assign(i) = downsampled_assign(I(1)); 
        elseif Y(1)<Y(2)/2
            assign(i) = downsampled_assign(I(1)); 
        else
            assign(i) = -downsampled_assign(I(1));
        end
        fprintf('\b\b\b\b\b\b\b\b\b\b%10d',i); drawnow;
    end
    fprintf('\n');
    all_assign{file_ind} = assign;

    
    [C,IA,IB] = intersect(downsampled_marker_names,marker_names);
    for i=1:size(adj,1)
        if sum(abs(assign)==i)==0
            node_median(file_ind,i,:)=NaN;
        else
            node_median(file_ind,i,IA)=reshape(nanmedian(data(IB,abs(assign)==i) ,2) , 1,1,length(IB));
        end
    end
    save(FlowSPD_output_upsample_filename,'node_median','all_assign');
    toc
end

all_marker_names = downsampled_marker_names;
save(FlowSPD_output_upsample_filename, 'all_marker_names', '-append')
return

% 
% %%%
% function [cluster_median] = get_cluster_median(data, idx)
% 
% cluster_median = zeros(size(data,1),max(idx))+NaN;
% for i=1:max(idx)
%     ind = find(idx==i);
%     if ~isempty(ind)
%         cluster_median(:,i) = median(data(:,ind),2);
%     end
% end
% return
% 
% 
